var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import { polyfill } from 'react-lifecycles-compat';
import PropTypes from 'prop-types';
import hoist, { extractRef } from '../hoist';
import StoreContext from '../../contexts/Store';
import withStore from './withStore';
import dispatcherStore from '../../stores/dispatcherStore';
import routerStore from '../../stores/routerStore';

export default function withStoreProvider() {
	var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	var useCache = options.useCache,
	    syncLocation = options.syncLocation,
	    _options$prop = options.prop,
	    prop = _options$prop === undefined ? 'store' : _options$prop,
	    type = options.type,
	    tableOption = options.table;

	return function createStoreProviderComponent(WrappedComponent) {
		var _dec, _dec2, _class, _class2, _temp, _initialiseProps;

		var WithStoreProvider = (_dec = hoist(WrappedComponent), _dec2 = withStore({ prop: 'parentStore' }), _dec(_class = _dec2(_class = polyfill(_class = (_temp = _class2 = function (_Component) {
			_inherits(WithStoreProvider, _Component);

			_createClass(WithStoreProvider, null, [{
				key: 'getDerivedStateFromProps',
				value: function getDerivedStateFromProps(_ref, prevState) {
					var table = _ref.table;

					return prevState.table && prevState.table !== table ? _defineProperty({}, prop, prevState.getStore(table)) : null;
				}
			}]);

			function WithStoreProvider(props, context) {
				_classCallCheck(this, WithStoreProvider);

				var _this = _possibleConstructorReturn(this, (WithStoreProvider.__proto__ || Object.getPrototypeOf(WithStoreProvider)).call(this, props, context));

				_initialiseProps.call(_this);

				var table = props.table,
				    parentStore = props.parentStore;

				var state = { table: table, getStore: _this._getStore };
				var targetTable = tableOption || table;
				var store = void 0;
				if (targetTable) store = _this._getStore(targetTable);else if (props.store) store = props.store;
				if (parentStore) {
					if (store) store.parent = parentStore;else store = parentStore;
				}
				state[prop] = store;
				_this.state = state;
				return _this;
			}

			_createClass(WithStoreProvider, [{
				key: 'componentWillUnmount',
				value: function componentWillUnmount() {
					var store = this.state[prop];
					store && store.unmount();
				}
			}, {
				key: 'render',
				value: function render() {
					var state = this.state,
					    _props = this.props,
					    parentStore = _props.parentStore,
					    props = _objectWithoutProperties(_props, ['parentStore']);

					var newProps = _defineProperty({}, prop, state[prop]);
					return React.createElement(
						StoreContext.Provider,
						{ value: state[prop] },
						React.createElement(WrappedComponent, _extends({}, extractRef(props), newProps))
					);
				}
			}]);

			return WithStoreProvider;
		}(Component), _class2.propTypes = {
			table: PropTypes.string,
			store: PropTypes.object,
			parentStore: PropTypes.object
		}, _initialiseProps = function _initialiseProps() {
			this._getStore = function (table) {
				var store = dispatcherStore.ensureStore(table, {
					useCache: useCache,
					router: syncLocation ? routerStore : null,
					type: type
				});
				store.mount();
				return store;
			};
		}, _temp)) || _class) || _class) || _class);

		return WithStoreProvider;
	};
}