'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = withStoreProvider;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactLifecyclesCompat = require('react-lifecycles-compat');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _hoist = require('../hoist');

var _hoist2 = _interopRequireDefault(_hoist);

var _Store = require('../../contexts/Store');

var _Store2 = _interopRequireDefault(_Store);

var _withStore = require('./withStore');

var _withStore2 = _interopRequireDefault(_withStore);

var _dispatcherStore = require('../../stores/dispatcherStore');

var _dispatcherStore2 = _interopRequireDefault(_dispatcherStore);

var _routerStore = require('../../stores/routerStore');

var _routerStore2 = _interopRequireDefault(_routerStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function withStoreProvider() {
	var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	var useCache = options.useCache,
	    syncLocation = options.syncLocation,
	    _options$prop = options.prop,
	    prop = _options$prop === undefined ? 'store' : _options$prop,
	    type = options.type,
	    tableOption = options.table;

	return function createStoreProviderComponent(WrappedComponent) {
		var _dec, _dec2, _class, _class2, _temp, _initialiseProps;

		var WithStoreProvider = (_dec = (0, _hoist2.default)(WrappedComponent), _dec2 = (0, _withStore2.default)({ prop: 'parentStore' }), _dec(_class = _dec2(_class = (0, _reactLifecyclesCompat.polyfill)(_class = (_temp = _class2 = function (_Component) {
			_inherits(WithStoreProvider, _Component);

			_createClass(WithStoreProvider, null, [{
				key: 'getDerivedStateFromProps',
				value: function getDerivedStateFromProps(_ref, prevState) {
					var table = _ref.table;

					return prevState.table && prevState.table !== table ? _defineProperty({}, prop, prevState.getStore(table)) : null;
				}
			}]);

			function WithStoreProvider(props, context) {
				_classCallCheck(this, WithStoreProvider);

				var _this = _possibleConstructorReturn(this, (WithStoreProvider.__proto__ || Object.getPrototypeOf(WithStoreProvider)).call(this, props, context));

				_initialiseProps.call(_this);

				var table = props.table,
				    parentStore = props.parentStore;

				var state = { table: table, getStore: _this._getStore };
				var targetTable = tableOption || table;
				var store = void 0;
				if (targetTable) store = _this._getStore(targetTable);else if (props.store) store = props.store;
				if (parentStore) {
					if (store) store.parent = parentStore;else store = parentStore;
				}
				state[prop] = store;
				_this.state = state;
				return _this;
			}

			_createClass(WithStoreProvider, [{
				key: 'componentWillUnmount',
				value: function componentWillUnmount() {
					var store = this.state[prop];
					store && store.unmount();
				}
			}, {
				key: 'render',
				value: function render() {
					var state = this.state,
					    _props = this.props,
					    parentStore = _props.parentStore,
					    props = _objectWithoutProperties(_props, ['parentStore']);

					var newProps = _defineProperty({}, prop, state[prop]);
					return _react2.default.createElement(
						_Store2.default.Provider,
						{ value: state[prop] },
						_react2.default.createElement(WrappedComponent, _extends({}, (0, _hoist.extractRef)(props), newProps))
					);
				}
			}]);

			return WithStoreProvider;
		}(_react.Component), _class2.propTypes = {
			table: _propTypes2.default.string,
			store: _propTypes2.default.object,
			parentStore: _propTypes2.default.object
		}, _initialiseProps = function _initialiseProps() {
			this._getStore = function (table) {
				var store = _dispatcherStore2.default.ensureStore(table, {
					useCache: useCache,
					router: syncLocation ? _routerStore2.default : null,
					type: type
				});
				store.mount();
				return store;
			};
		}, _temp)) || _class) || _class) || _class);

		return WithStoreProvider;
	};
}